<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTachoEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfTachoEvent extends AbstractStructArrayBase
{
    /**
     * The TachoEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TachoEvent[]
     */
    public $TachoEvent;
    /**
     * Constructor method for ArrayOfTachoEvent
     * @uses ArrayOfTachoEvent::setTachoEvent()
     * @param \StructType\TachoEvent[] $tachoEvent
     */
    public function __construct(array $tachoEvent = array())
    {
        $this
            ->setTachoEvent($tachoEvent);
    }
    /**
     * Get TachoEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TachoEvent[]|null
     */
    public function getTachoEvent()
    {
        return isset($this->TachoEvent) ? $this->TachoEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTachoEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTachoEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTachoEventForArrayConstraintsFromSetTachoEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTachoEventTachoEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfTachoEventTachoEventItem instanceof \StructType\TachoEvent) {
                $invalidValues[] = is_object($arrayOfTachoEventTachoEventItem) ? get_class($arrayOfTachoEventTachoEventItem) : sprintf('%s(%s)', gettype($arrayOfTachoEventTachoEventItem), var_export($arrayOfTachoEventTachoEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TachoEvent property can only contain items of type \StructType\TachoEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TachoEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TachoEvent[] $tachoEvent
     * @return \ArrayType\ArrayOfTachoEvent
     */
    public function setTachoEvent(array $tachoEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($tachoEventArrayErrorMessage = self::validateTachoEventForArrayConstraintsFromSetTachoEvent($tachoEvent))) {
            throw new \InvalidArgumentException($tachoEventArrayErrorMessage, __LINE__);
        }
        if (is_null($tachoEvent) || (is_array($tachoEvent) && empty($tachoEvent))) {
            unset($this->TachoEvent);
        } else {
            $this->TachoEvent = $tachoEvent;
        }
        return $this;
    }
    /**
     * Add item to TachoEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\TachoEvent $item
     * @return \ArrayType\ArrayOfTachoEvent
     */
    public function addToTachoEvent(\StructType\TachoEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TachoEvent) {
            throw new \InvalidArgumentException(sprintf('The TachoEvent property can only contain items of type \StructType\TachoEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TachoEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TachoEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TachoEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TachoEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TachoEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TachoEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TachoEvent
     */
    public function getAttributeName()
    {
        return 'TachoEvent';
    }
}
